import { ProcedureRecord } from '@trpc/server';
import { DefaultErrorShape, Router } from '@trpc/server/dist/declarations/src/router';
import { TRPC_ERROR_CODE_KEY } from '@trpc/server/dist/declarations/src/rpc';
import { OpenAPIV3 } from 'openapi-types';
import { ZodIssue } from 'zod';
export declare type OpenApiMethod = 'GET' | 'POST' | 'PATCH' | 'PUT' | 'DELETE';
declare type TRPCMeta = Record<string, any>;
export declare type OpenApiMeta<TMeta = TRPCMeta> = TMeta & {
    openapi?: {
        enabled?: boolean;
        method: OpenApiMethod;
        path: `/${string}`;
        summary?: string;
        description?: string;
        protect?: boolean;
        headers?: (OpenAPIV3.ParameterBaseObject & {
            name: string;
            in?: 'header';
        })[];
    } & ({
        tags?: never;
        /** @deprecated Use `tags` instead */
        tag?: string;
    } | {
        tags?: string[];
        /** @deprecated Use `tags` instead */
        tag?: never;
    });
};
export declare type OpenApiProcedureRecord<TMeta = TRPCMeta> = ProcedureRecord<any, any, OpenApiMeta<TMeta> | undefined, any, any, any, any>;
export declare type OpenApiProcedure<TMeta = TRPCMeta> = OpenApiProcedureRecord<TMeta>[string];
export declare type OpenApiRouter<TContext = any, TMeta = TRPCMeta> = Router<TContext, TContext, OpenApiMeta<TMeta>, OpenApiProcedureRecord<TMeta>, OpenApiProcedureRecord<TMeta>, ProcedureRecord<any, any, TMeta | undefined, any, any, any, any>, DefaultErrorShape>;
export declare type OpenApiSuccessResponse<D = any> = D;
export declare type OpenApiErrorResponse = {
    message: string;
    code: TRPC_ERROR_CODE_KEY;
    issues?: ZodIssue[];
};
export declare type OpenApiResponse<D = any> = OpenApiSuccessResponse<D> | OpenApiErrorResponse;
export {};
//# sourceMappingURL=types.d.ts.map