"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.forEachOpenApiProcedure = exports.mergeProcedureRecords = exports.getInputOutputParsers = void 0;
// `inputParser` & `outputParser` are private so this is a hack to access it
const getInputOutputParsers = (procedure) => {
    return procedure;
};
exports.getInputOutputParsers = getInputOutputParsers;
const mergeProcedureRecords = (queries, mutations) => {
    const prefix = (procedures, type) => {
        const next = {};
        Object.keys(procedures).forEach((path) => {
            next[`${type}.${path}`] = procedures[path];
        });
        return next;
    };
    return Object.assign(Object.assign({}, prefix(queries, 'query')), prefix(mutations, 'mutation'));
};
exports.mergeProcedureRecords = mergeProcedureRecords;
const forEachOpenApiProcedure = (procedureRecord, callback) => {
    var _a;
    for (const [path, procedure] of Object.entries(procedureRecord)) {
        const { openapi } = (_a = procedure.meta) !== null && _a !== void 0 ? _a : {};
        if (openapi && openapi.enabled !== false) {
            callback({ path, procedure, openapi });
        }
    }
};
exports.forEachOpenApiProcedure = forEachOpenApiProcedure;
//# sourceMappingURL=procedure.js.map